#include <stdio.h>
#include <string.h>
#include "cui.h"
#include "esc.h"
#include "handler.h"
#include "label.h"
#include "button.h"
#include "ckbox.h"
#include "radio.h"
#include "dialog.h"
#include "menu.h"

int
joke_hdr(cui obj, int evt, int val, void *prm)
{
	cui lb = (cui)prm, b2 = lb->children, b1 = b2->next;
	char *s = cui_button_str_get(obj);

	if(strcmp(s, "reboot") == 0 || strcmp(s, "power off") == 0){
		cui_label_str_set(lb, "It's a joke");
		cui_button_str_set(b1, "sorry");
		cui_x_set(b1, cui_x2(lb) + 1);
		cui_hide(b2);
		cui_focus_set(b1);
		cui_w_set(lb, cui_x2(b1));
	}else{
		cui_hide(lb);	
		cui_focus_set(NULL);
		cui_draw(lb->parent);
		cui_quit();
	}
	return TRUE;
}

cui
joke_new(cui parent, int x, int y)
{
	cui lb = cui_label_new(parent, x, y, "system panic!");
	cui b1 = cui_button_new(lb, lb->w + 1, 0, "reboot");
	cui b2 = cui_button_new(lb, cui_x2(b1) + 1, 0, "power off");
	cui_w_set(lb, cui_x2(b2));
	cui_bind(b1, CUI_EVT_BUTTON, joke_hdr, lb);
	cui_bind(b2, CUI_EVT_BUTTON, joke_hdr, lb);
	return lb;
}

int
my_hdr(cui obj, int evt, int val, void *prm)
{
	cui joke;
	cui_simple_dialog p = (cui_simple_dialog)prm;
	cui_label_str_set(p->label, "Realy ?");
	cui_button_str_set(p->btn1, "Yes");
	cui_button_str_set(p->btn2, "No");
	cui_unbind(obj, CUI_EVT_BUTTON, my_hdr);
	joke = joke_new(((cui)p)->parent->parent->parent, 0, 4);
	cui_main(joke, joke->children->next);
	cui_del(joke);
	cui_free(joke);
	return TRUE;
}

int
my_hdr2(cui obj, int evt, int val, void *prm)
{
	cui dlg = (cui)prm;
	if(val) cui_show(dlg);
	else cui_hide(dlg);
	return TRUE;
}

int
mv_hdr(cui obj, int evt, int val, void *prm)
{
	static char buf[16];

	cui_xywh_set(obj, obj->x, obj->y + 1, obj->w, obj->h);
	sprintf(buf, "%d", cui_gy(obj));
	cui_label_str_set((cui)prm, buf);
	return TRUE;
}

int
arrow_hdr(cui obj, int evt, int val, void *prm)
{
	cui big = (cui)prm;
	char *s = cui_button_str_get(obj);
	int x = big->x, y = big->y;

	if(strcmp(s, "L") == 0) x++; 
	else if (strcmp(s, "R") == 0) x--; 
	else if (strcmp(s, "U") == 0) y++; 
	else if (strcmp(s, "D") == 0) y--; 
	cui_xywh_set(big, x, y, big->w, big->h);
	return TRUE;
}

cui
arrow_new(cui parent, int x, int y, void *prm)
{
	cui base = cui_base_new(parent, x, y, 0, 0);
	cui al = cui_button_new(base, 0, 1, "L");
	cui ad = cui_button_new(base, cui_x2(al), 1, "D");
	cui ar = cui_button_new(base, cui_x2(ad), 1, "R");
	cui au = cui_button_new(base, ad->x, 0, "U");
	base->w = cui_x2(ar);
	base->h = 2;
	cui_bind(al, CUI_EVT_BUTTON, arrow_hdr, prm);
	cui_bind(ad, CUI_EVT_BUTTON, arrow_hdr, prm);
	cui_bind(ar, CUI_EVT_BUTTON, arrow_hdr, prm);
	cui_bind(au, CUI_EVT_BUTTON, arrow_hdr, prm);
	return base;
}

int
radio_hdr(cui obj, int evt, int val, void *prm)
{
	char *s = cui_radio_str_get(obj);
	if(!val) return TRUE;
	if(strcmp(s, "ON") == 0) cui_show((cui)prm);
	else if(strcmp(s, "OFF") == 0) cui_hide((cui)prm);
	else{
		cui lb = obj->parent->parent->children;
		cui_label_str_set(lb, (char *)prm);
	}
	return TRUE;
}

cui
radio_new(cui parent, int x, int y)
{
	cui panel, lb, grp, rd_on, rd_off, base, grp2, rd[4], lb2;

	panel = cui_panel_new(parent, x, y, 0, 0);
	lb = cui_label_new(panel, 1, 1, "Radio");
	grp = cui_base_new(panel, lb->x+2, cui_y2(lb), 0, 0);
	rd_on = cui_radio_new(grp, 0, 0, "ON", 0);
	rd_off = cui_radio_new(grp, cui_x2(rd_on)+1, rd_on->y, "OFF", 1);
	cui_wh_fit(grp, grp->children);

	base = cui_base_new(panel, grp->x, cui_y2(grp), 0, 0);
	grp2 = cui_base_new(base, 0, 0, 0, 0);
	rd[0] = cui_radio_new(grp2, 0, 0, "ABC", 0);
	rd[1] = cui_radio_new(grp2, 0, 1, "KBS", 0);
	rd[2] = cui_radio_new(grp2, 0, 2, "MBS", 0);
	rd[3] = cui_radio_new(grp2, 0, 3, "OBC", 0);
	cui_wh_fit(grp2, grp2->children);
	lb2 = cui_label_new(base, cui_x2(grp2)+2, 0, "     kHz");
	cui_wh_fit(base, base->children);
	base->flags |= CUI_FLG_HIDE;

	cui_wh_fit(panel, panel->children);
	panel->w += 1;
	panel->h += 1;
	cui_panel_adj(panel);

	cui_bind(rd_on, CUI_EVT_BUTTON, radio_hdr, base);
	cui_bind(rd_off, CUI_EVT_BUTTON, radio_hdr, base);
	cui_bind(rd[0], CUI_EVT_BUTTON, radio_hdr, "1008 kHz");
	cui_bind(rd[1], CUI_EVT_BUTTON, radio_hdr, "1143 kHz");
	cui_bind(rd[2], CUI_EVT_BUTTON, radio_hdr, "1179 kHz");
	cui_bind(rd[3], CUI_EVT_BUTTON, radio_hdr, "1314 kHz");
	return panel;	
}

int
mn_long_hdr(cui obj, int evt, int val, void *prm)
{
	cui menu = (cui)prm;

	if(menu){ /* menu_btn */
		cui_show(menu);
		cui_main(menu, cui_index_to_child(menu, 0));
		cui_hide(menu);
		cui_draw(menu->parent);
		return TRUE;
	}
	/* prm == NULL (menu) */
	cui_quit();
	return TRUE;
}

cui
mn_long_new(cui parent, int x, int y)
{
	cui mn_btn = cui_menu_btn_new(parent, x, y, "LONG");
	cui menu;
	static char buf[20][16], *lst[21];
	int i;

	for(i=0; i<20; i++){
		lst[i] = buf[i];
		sprintf(lst[i], "cmd %d", i);
	}
	lst[20] = NULL;
	menu = cui_menu_new(parent, mn_btn->x, mn_btn->y+1, lst);
	menu->flags |= CUI_FLG_HIDE;
	cui_bind(mn_btn, CUI_EVT_BUTTON, mn_long_hdr, menu);
	cui_bind(menu, CUI_EVT_BUTTON, mn_long_hdr, NULL);
	return mn_btn;
}

int
popup_hdr(cui obj, int evt, int val, void *prm)
{
	cui lb = (cui)prm;
	static char buf[16];
	int last[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
	sprintf(buf, "last %d/%d", val+1, last[val]);
	cui_label_str_set(lb, buf);
	return TRUE;
}

cui
big_new(cui parent, int x, int y, cui_simple_dialog *res_dlg)
{
	cui base = cui_panel_new(parent, x, y, 0, 0);
	cui dlg = cui_simple_dialog_new(base, 0, 0, "Are you sure ?", "OK", "Cancel");
	cui_simple_dialog p = (cui_simple_dialog)dlg;	
	cui popup = cui_menu_popup_new(base, cui_x2(dlg)+1, cui_y2(dlg)+5, 8, 
		(char *[]){"January", "February", "March", "April", "May", "June", 
		"July", "August", "September", "October", "November", "December", NULL}, 0);
	cui lb = cui_label_new(base, cui_x2(popup)+2, popup->y, "last 1/31");

	radio_new(base, cui_x2(dlg)+1, dlg->y);
	cui_simple_dialog_new(base, dlg->x, cui_y2(dlg), "How are you ?", "^_^", "T_T");
	mn_long_new(base, cui_x2(dlg)+1, cui_y2(dlg)+3);
	cui_wh_fit(base, base->children);

	cui_bind(p->btn1, CUI_EVT_BUTTON, my_hdr, p);
	cui_bind(popup, CUI_EVT_BUTTON, popup_hdr, lb);
	*res_dlg = p;
	return base;
}

int
mn_hdr(cui obj, int evt, int val, void *prm)
{
	if(val >= 0){
		cui item = cui_index_to_child(obj, val);
		char *s = cui_menu_item_str_get(item);
		cui_label_str_set((cui)prm, s);
	}				  
	cui_quit();
	return TRUE;
}

int
mn_btn_hdr(cui obj, int evt, int val, void *prm)
{
	char *lst[] = {"Open", "Save", "Close", "Quit", NULL};
	cui menu = cui_menu_new(obj->parent, obj->x, obj->y+1, lst);

	cui_bind(menu, CUI_EVT_BUTTON, mn_hdr, prm);
	cui_main(menu, cui_menu_str_to_item(menu, "Open"));
	cui_hide(menu);
	cui_draw(menu->parent);
	cui_del(menu);
	cui_free(menu);

	if(strcmp(cui_label_str_get((cui)prm), "Quit") == 0) cui_quit();
	return TRUE;
}

int
main()
{
	cui base = cui_panel_new(NULL, 0, 0, 40, 20);
	cui mn_btn = cui_menu_btn_new(base, 1, 1, "File");
	cui ck = cui_ckbox_new(base, cui_x2(mn_btn)+2, 1, "Show", FALSE);
	cui mv_btn = cui_button_new(base, cui_x2(ck) + 2, ck->y, "move");
	cui mv_lb = cui_label_new(base, cui_x2(mv_btn) + 2, mv_btn->y, "");

	cui_simple_dialog p;
	cui small = cui_panel_new(base, 2, 3, base->w - (2 * 2), base->h - (3 + 1));
	cui small2 = cui_base_new(small, 1, 1, small->w - 2, small->h - 2);
	cui big = big_new(small2, 0, 0, &p);

	arrow_new(base, cui_x2(mv_lb) + 2, mv_lb->y, big);

	small->flags |= CUI_FLG_HIDE;
	cui_bind(mn_btn, CUI_EVT_BUTTON, mn_btn_hdr, mv_lb);
	cui_bind(ck, CUI_EVT_BUTTON, my_hdr2, small);
	cui_bind(mv_btn, CUI_EVT_BUTTON, mv_hdr, mv_lb);

	cui_main(base, NULL);
	printf("result %s\n", p->btn_result);
	cui_free(base);
	return 0;
}

/* EOF */
