#ifndef __HANDLER_H__
#define __HANDLER_H__

#include "cui.h"

typedef int (*cui_handler)(cui obj, int evt, int val, void *prm);

struct cui_handler_list{
	cui_handler hdr;
	int evt;
	void *prm;
	cui_handler_list next;
};

cui_handler_list cui_handler_list_new(cui_handler hdr, int evt, void *prm, cui_handler_list next);
void cui_handler_list_free(cui_handler_list list);
void cui_bind(cui obj, int evt, cui_handler hdr, void *prm);
void cui_unbind(cui obj, int evt, cui_handler hdr);
int cui_handler_call(cui obj, cui_handler_list list, int evt, int val);

#endif
