#include "radio.h"
#include "handler.h"
#include "key.h"
#include <stdio.h>

cui
cui_radio_new(cui parent, int x, int y, char *s, int v)
{
	cui obj = cui_alloc(sizeof(struct cui_radio));
	cui_radio_init(obj, parent, x, y, s, v);
	return obj;
}

void
cui_radio_toggle(cui obj)
{
	cui_ckbox ck = (cui_ckbox)obj;
	
	ck->v = !ck->v;
	cui_label_str_set(ck->lb1, ck->v ? "(O) " : "( ) ");
	cui_handler_call(obj, obj->handler_list, CUI_EVT_BUTTON, ck->v);
}

cui
cui_radio_sel_get(cui obj)
{
	cui_ckbox ck = (cui_ckbox)obj;
	if(obj == NULL) return NULL;
	if(ck->v) return obj;
	return cui_radio_sel_get(obj->next);
}

int
cui_radio_hdr(cui obj, int evt, int val, void *prm)
{
	cui_ckbox ck = (cui_ckbox)obj;
	cui old;

	if(val != CUI_KEY_ENTER) return FALSE;
	if(ck->v) return TRUE;
	old = cui_radio_sel_get(obj->parent->children);
	if(old) cui_radio_toggle(old);
	cui_radio_toggle(obj);
	return TRUE;
}

void
cui_radio_init(cui obj, cui parent, int x, int y, char *s, int v)
{
	cui_ckbox ck = (cui_ckbox)obj;
	cui_ckbox_init(obj, parent, x, y, s, v);
	obj->flags |= CUI_FLG_HIDE;
	cui_label_str_set(ck->lb1, v ? "(O) " : "( ) ");
	obj->flags &= ~CUI_FLG_HIDE;
	cui_bind(obj, CUI_EVT_KEY, cui_radio_hdr, NULL);
}

char *
cui_radio_str_get(cui obj)
{
	return cui_ckbox_str_get(obj);
}

void
cui_radio_str_set(cui obj, char *s)
{
	cui_ckbox_str_set(obj, s);
}

/* EOF */
