#include "rect.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void
cui_rect_init(cui_rect r, int x, int y, int w, int h)
{
	r->x = x;
	r->y = y;
	r->w = w;
	r->h = h;
}

void
cui_rect_wh_to_x2y2(cui_rect r)
{
	r->w += r->x;
	r->h += r->y;
}

void
cui_rect_x2y2_to_wh(cui_rect r)
{
	r->w -= r->x;
	r->h -= r->y;
}

int
cui_rect_and(cui_rect a, cui_rect b, cui_rect r)
{
	struct cui_rect tmp;
	cui_rect t = &tmp;

	cui_rect_wh_to_x2y2(a);
	cui_rect_wh_to_x2y2(b);
	cui_rect_init(t,
		a->x > b->x ? a->x : b->x,
		a->y > b->y ? a->y : b->y,
		a->w < b->w ? a->w : b->w,
		a->h < b->h ? a->h : b->h);
	cui_rect_x2y2_to_wh(t);
	cui_rect_x2y2_to_wh(a);
	cui_rect_x2y2_to_wh(b);
	*r = *t;
	return !cui_rect_chk_empty(r);
}

int
cui_rect_chk_empty(cui_rect r)
{
	return r->w <= 0 || r->h <= 0;
}

/* EOF */
